Index: issm/trunk/m4/issm_options.m4
===================================================================
--- issm/trunk/m4/issm_options.m4	(revision 12709)
+++ issm/trunk/m4/issm_options.m4	(revision 13395)
@@ -12,5 +12,22 @@
 		AC_DEFINE([_ISSM_DEBUG_],[1],[Macro to enable debugging in ISSM])
 	fi
-	dnl }}}
+
+	dnl }}}
+    dnl shared build {{{
+    AC_ARG_ENABLE([sharedlibs],                                                dnl feature
+        AS_HELP_STRING([--enable-sharedlibs], [produce libISSM.so.0]),         dnl help string
+        [enable_sharedlibs=$enableval],                                        dnl action if given
+        [enable_sharedlibs=no])                                                dnl action if not given
+    AM_CONDITIONAL([SHAREDLIBS], [test x$enable_sharedlibs = xyes])
+    dnl }}}
+
+    dnl shared build {{{
+    AC_ARG_ENABLE([version],                                                dnl feature
+        AS_HELP_STRING([--enable-version], [produce libISSM.so.0]),         dnl help string
+        [enable_version=$enableval],                                        dnl action if given
+        [enable_version=no])                                                dnl action if not given
+    AM_CONDITIONAL([VERSION], [test x$enable_VERSION = xyes])
+    dnl }}}
+
 	dnl Modules build {{{
 	AC_ARG_WITH([modules],
@@ -164,42 +181,46 @@
 		MATLABINCL=-I"$MATLAB_ROOT/extern/include";
 		
-		dnl OS-dependent variables and checks
-		case "${host_os}" in
-			*linux*)
-				if test "${host_cpu}" = "x86_64";
-				then
-					MEXLIB=-L"$MATLAB_ROOT/bin/glnxa64/ -lmex"
-					MEXLINK="-pthread -shared -W2,--version-script,${MATLAB_ROOT}/extern/lib/glnxa64/mexFunction.map";
-				else
-					MEXLIB=-L"$MATLAB_ROOT/bin/glnx86/ -lmex"
-					MEXLINK="-pthread -shared -W2,--version-script,${MATLAB_ROOT}/extern/lib/glnx86/mexFunction.map";
-				fi
-				MEXEXT=`$MATLAB_ROOT/bin/mexext`
-				MEXEXT=".$MEXEXT"
-			;;
-			*darwin*)
-				dnl mex -v gives all the flags for compilation of mex files
-				dnl if matlab version is 7.9 or more, we must use mexmaci64 (64 bits)
-				MEXLINK="-O -Wl,-flat_namespace -undefined suppress -arch i386 -bundle -Wl,-exported_symbols_list,$MATLAB_ROOT/extern/lib/maci/mexFunction.map"
-				MEXLIB=" -L$MATLAB_ROOT/bin/maci/ -lmx -lmex -lmat -lstdc++ -largeArrayDims"
-				if test $MATLAB_MAJOR -ge 7; then 
-					 if test $MATLAB_MINOR -ge 9; then 
-						  MEXLINK="-O -Wl,-flat_namespace -undefined suppress -bundle -Wl,-exported_symbols_list,$MATLAB_ROOT/extern/lib/maci64/mexFunction.map"
-							 MEXLIB=" -L$MATLAB_ROOT/bin/maci64/ -lmx -lmex -lmat -lstdc++"
-					 fi
-				fi
-				MEXEXT=`$MATLAB_ROOT/bin/mexext`
-				MEXEXT=".$MEXEXT"
-			;;
-			*cygwin*) 
-				if  test $VENDOR = intel-win7-32; then
-					MEXLIB="-dll -export:mexFunction -LIBPATH:\"$MATLAB_ROOT\extern\lib\win32\microsoft\" libmx.lib libmex.lib libmat.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib  -NOLOGO -INCREMENTAL:NO -manifest" 
-				elif  test $VENDOR = intel-win7-64; then
-					MEXLIB="-dll -export:mexFunction -LIBPATH:\"$MATLAB_ROOT\extern\lib\win64\microsoft\" libmx.lib libmex.lib libmat.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib  -NOLOGO -INCREMENTAL:NO -manifest" 
-				fi
-				MEXEXT=`$MATLAB_ROOT/bin/mexext.bat`
-				MEXEXT=".$MEXEXT"
-			;;
-		esac
+		dnl 4. get MEXLIB MEXLINK and MEXEXT (experimental)
+		MEXLINK=$(mex -v 2>&1 < /dev/null | grep LDFLAGS     | sed -e "s/         LDFLAGS            = //g")
+		MEXLIB=$( mex -v 2>&1 < /dev/null | grep CXXLIBS     | sed -e "s/         CXXLIBS            = //g")
+		MEXEXT=$( mex -v 2>&1 < /dev/null | grep LDEXTENSION | sed -e "s/         LDEXTENSION        = //g")
+		dnl dnl OS-dependent variables and checks (old stuff)
+		dnl case "${host_os}" in
+		dnl 	*linux*)
+		dnl 		if test "${host_cpu}" = "x86_64";
+		dnl 		then
+		dnl 			MEXLIB="-Wl,-rpath-link,$MATLAB_ROOT/bin/glnxa64 -L$MATLAB_ROOT/bin/glnxa64/ -lmx -lmex -lmat -lm"
+		dnl 			MEXLINK="-pthread -shared -W2,--version-script,${MATLAB_ROOT}/extern/lib/glnxa64/mexFunction.map";
+		dnl 		else
+		dnl 			MEXLIB=-L"$MATLAB_ROOT/bin/glnx86/ -lmex"
+		dnl 			MEXLINK="-pthread -shared -W2,--version-script,${MATLAB_ROOT}/extern/lib/glnx86/mexFunction.map";
+		dnl 		fi
+		dnl 		MEXEXT=`$MATLAB_ROOT/bin/mexext`
+		dnl 		MEXEXT=".$MEXEXT"
+		dnl 	;;
+		dnl 	*darwin*)
+		dnl 		dnl mex -v gives all the flags for compilation of mex files
+		dnl 		dnl if matlab version is 7.9 or more, we must use mexmaci64 (64 bits)
+		dnl 		MEXLINK="-O -Wl,-flat_namespace -undefined suppress -arch i386 -bundle -Wl,-exported_symbols_list,$MATLAB_ROOT/extern/lib/maci/mexFunction.map"
+		dnl 		MEXLIB=" -L$MATLAB_ROOT/bin/maci/ -lmx -lmex -lmat -lstdc++ -largeArrayDims"
+		dnl 		if test $MATLAB_MAJOR -ge 7; then 
+		dnl 			 if test $MATLAB_MINOR -ge 9; then 
+		dnl 				  MEXLINK="-O -Wl,-flat_namespace -undefined suppress -bundle -Wl,-exported_symbols_list,$MATLAB_ROOT/extern/lib/maci64/mexFunction.map"
+		dnl 					 MEXLIB=" -L$MATLAB_ROOT/bin/maci64/ -lmx -lmex -lmat -lstdc++"
+		dnl 			 fi
+		dnl 		fi
+		dnl 		MEXEXT=`$MATLAB_ROOT/bin/mexext`
+		dnl 		MEXEXT=".$MEXEXT"
+		dnl 	;;
+		dnl 	*cygwin*) 
+		dnl 		if  test $VENDOR = intel-win7-32; then
+		dnl 			MEXLIB="-dll -export:mexFunction -LIBPATH:\"$MATLAB_ROOT\extern\lib\win32\microsoft\" libmx.lib libmex.lib libmat.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib  -NOLOGO -INCREMENTAL:NO -manifest" 
+		dnl 		elif  test $VENDOR = intel-win7-64; then
+		dnl 			MEXLIB="-dll -export:mexFunction -LIBPATH:\"$MATLAB_ROOT\extern\lib\win64\microsoft\" libmx.lib libmex.lib libmat.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib  -NOLOGO -INCREMENTAL:NO -manifest" 
+		dnl 		fi
+		dnl 		MEXEXT=`$MATLAB_ROOT/bin/mexext.bat`
+		dnl 		MEXEXT=".$MEXEXT"
+		dnl 	;;
+		dnl esac
 	   AC_MSG_RESULT(done)
 
@@ -208,5 +229,5 @@
 		MATLABWRAPPEREXT=$MEXEXT
 		AC_SUBST([MATLABWRAPPEREXT])
-		AC_SUBST([MEXLIB]) 
+	    AC_SUBST([MEXLIB]) 
 		AC_SUBST([MEXLINK])
 	fi
@@ -315,5 +336,22 @@
 	if test -d "$PYTHON_ROOT"; then
 		dnl defaults
+		HAVE_PYTHON3="no"
 		HAVE_PYTHON=yes
+		
+		AC_ARG_WITH([python-version],
+		  AS_HELP_STRING([--with-python-version = PYTHONVERSION],[python version.]),
+		  [PYTHONVERSION=$withval],[PYTHONVERSION=""])
+		AC_MSG_CHECKING(for python version)
+
+		dnl recover major: 
+		PYTHON_MAJOR=${PYTHONVERSION%.*}
+
+		if test x$PYTHON_MAJOR = x3; then
+			dnl are we running python 3?
+			HAVE_PYTHON3="yes"
+		fi
+		AC_DEFINE_UNQUOTED([_PYTHON_MAJOR_],$PYTHON_MAJOR,[python version major])
+		AC_MSG_RESULT($PYTHON_MAJOR)
+
 		PYTHONINCL=-I$PYTHON_ROOT/include
 		PYTHONLIB="-L$PYTHON_ROOT/lib -lpython$PYTHONVERSION"
@@ -342,25 +380,7 @@
 	fi
 	AM_CONDITIONAL([PYTHON], [test x$HAVE_PYTHON = xyes])
+	AM_CONDITIONAL([PYTHON3], [test x$HAVE_PYTHON3 = xyes])
 	AC_MSG_RESULT($HAVE_PYTHON)
 
-	dnl python-version
-	HAVE_PYTHON3="no"
-	if test x$HAVE_PYTHON = xyes; then
-		AC_ARG_WITH([python-version],
-		  AS_HELP_STRING([--with-python-version = PYTHONVERSION],[python version.]),
-		  [PYTHONVERSION=$withval],[PYTHONVERSION=""])
-		AC_MSG_CHECKING(for python version)
-
-		dnl recover major: 
-		PYTHON_MAJOR=${PYTHONVERSION%.*}
-
-		if test x$PYTHON_MAJOR = x3; then
-			dnl are we running python 3?
-			HAVE_PYTHON3="yes"
-		fi
-		AC_DEFINE_UNQUOTED([_PYTHON_MAJOR_],$PYTHON_MAJOR,[python version major])
-		AC_MSG_RESULT($PYTHON_MAJOR)
-	fi
-	AM_CONDITIONAL([PYTHON3], [test x$HAVE_PYTHON3 = xyes])
 	dnl }}}
 	dnl python-numpy{{{
@@ -373,5 +393,5 @@
 		dnl defaults
 		HAVE_PYTHON_NUMPY=yes
-		PYTHON_NUMPYINCL=-I$PYTHON_NUMPY_ROOT
+		PYTHON_NUMPYINCL="-I$PYTHON_NUMPY_ROOT -I$PYTHON_NUMPY_ROOT/core/include/numpy"
 
 		AC_DEFINE([_HAVE_PYTHON_NUMPY_],[1],[with Python-Numpy in ISSM src])
@@ -454,4 +474,13 @@
 	AC_MSG_RESULT($HAVE_ADOLC)
 	dnl }}}
+	dnl adolc-version{{{
+	AC_ARG_WITH([adolc-version],
+		AS_HELP_STRING([--with-adolc-version=number], [adolc version.]),
+		[ADOLC_VERSION=$withval],[ADOLC_VERSION=2]) 
+	AC_MSG_CHECKING(for adolc-version) 
+
+	AC_DEFINE_UNQUOTED([_ADOLC_VERSION_],$ADOLC_VERSION,[ADOLC version])
+	AC_MSG_RESULT($ADOLC_VERSION)
+	dnl }}}
 	dnl adic2{{{
 	AC_ARG_WITH([adic2-dir],
@@ -493,5 +522,5 @@
 		HAVE_GSL=yes
 		GSLINCL="-I$GSL_ROOT/include"
-		GSLLIB="-L$GSL_ROOT/lib/ -lgsl -lgslcblas -lm"
+		GSLLIB="-dy -L$GSL_ROOT/lib -lgsl -lgslcblas -lm"
 
 		AC_DEFINE([_HAVE_GSL_],[1],[with gsl in ISSM src])
@@ -533,7 +562,7 @@
 	  [METIS_ROOT=$withval],[METIS_ROOT=""])
 
+   AC_MSG_CHECKING(for metis headers and libraries in $METIS_ROOT)
+
 	if test -d "$METIS_ROOT"; then
-
-		AC_MSG_CHECKING(for metis headers and libraries in $METIS_ROOT)
 
 		dnl first figure out version of metis: does the VERSION file exist?
@@ -577,5 +606,5 @@
 				;;
 			esac
-	
+
 			METISINCL=-I"$METIS_ROOT/include" 
 			AC_DEFINE([_METIS_VERSION_],[5],[ Metis version number])
@@ -589,9 +618,10 @@
 	fi
 	AM_CONDITIONAL([METIS], [test x$HAVE_METIS = xyes])
+	AC_MSG_RESULT($HAVE_METIS)
 	dnl }}}
 	dnl mpi{{{
 	AC_MSG_CHECKING(for mpi)
 	AC_ARG_WITH([mpi-lib],
-		AS_HELP_STRING([--with-mpi-lib = otions],[mpi options, for ex: "-L$MPIROOT -lmpich]),
+		AS_HELP_STRING([--with-mpi-lib = options],[mpi options, for ex: "-L$MPIROOT -lmpich]),
 		[MPILIB=$withval],[MPILIB=""])
 	
@@ -607,5 +637,5 @@
 		else
 			HAVE_MPI=yes
-			MPIINCL=-I"$MPI_INCLUDE/"
+			MPIINCL=-I"$MPI_INCLUDE"
 			AC_DEFINE([_HAVE_MPI_],[1],[with Mpi in ISSM src])
 			AC_DEFINE([HAVE_MPI],[1],[Mpi Flag for Dakota (DO NOT REMOVE)])
@@ -646,4 +676,7 @@
 	AC_MSG_CHECKING(for petsc headers and libraries in $PETSC_ROOT for architecture $PETSC_ARCH)
 	
+	dnl To ge PETSc's libraries:
+	dnl cd externalpackages/petsc/src
+	dnl make getlinklibs
 	if test -d "$PETSC_ROOT"; then
 
@@ -653,21 +686,21 @@
 			*cygwin*)
 			if test "$PETSC_MAJOR" = "2" ; then
-				PETSCLIB="-link -LIBPATH:\"$PETSC_ROOT/$PETSC_ARCH/lib\" -LIBPATH:\"$PETSC_ROOT/lib\" -LIBPATH:\"$PETSC_ROOT/lib/$PETSC_ARCH\" libpetscksp.lib  libpetscdm.lib  libpetscmat.lib  libpetscvec.lib libpetscsnes.lib libpetscts.lib libmpiuni.lib libpetsc.lib"
+				PETSCLIB="-link -LIBPATH:\"$PETSC_ROOT/lib\" -LIBPATH:\"$PETSC_ROOT/lib\" -LIBPATH:\"$PETSC_ROOT/lib/$PETSC_ARCH\" libpetscksp.lib  libpetscdm.lib  libpetscmat.lib  libpetscvec.lib libpetscsnes.lib libpetscts.lib libmpiuni.lib libpetsc.lib"
 			else
-				PETSCLIB="-link -LIBPATH:\"$PETSC_ROOT/$PETSC_ARCH/lib\" -LIBPATH:\"$PETSC_ROOT/lib\" -LIBPATH:\"$PETSC_ROOT/lib/$PETSC_ARCH\" libpetsc.lib"
+				PETSCLIB="-link -LIBPATH:\"$PETSC_ROOT/lib\" -LIBPATH:\"$PETSC_ROOT/lib\" -LIBPATH:\"$PETSC_ROOT/lib/$PETSC_ARCH\" libpetsc.lib"
 			fi
 			;;
 			*linux*)
 			if test "$PETSC_MAJOR" = "2" ; then
-			PETSCLIB="-L$PETSC_ROOT/$PETSC_ARCH/lib -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetscksp -lpetscdm -lpetscmat -lpetscvec -lpetsc  -lpetscsnes -lpetscts"
+			PETSCLIB="-L$PETSC_ROOT/lib -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetscksp -lpetscdm -lpetscmat -lpetscvec -lpetsc  -lpetscsnes -lpetscts"
 			else
-			PETSCLIB="-L$PETSC_ROOT/$PETSC_ARCH/lib -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetsc"
+			PETSCLIB="-L$PETSC_ROOT/lib -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetsc -ldl"
 			fi
 			;;
 			*darwin*)
 			if test "$PETSC_MAJOR" = "2" ; then
-			PETSCLIB="-L$PETSC_ROOT/$PETSC_ARCH/lib -L$PETSC_ROOT/lib/$PETSC_ARCH/ -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetscksp -lpetscdm -lpetscmat -lpetscvec -lpetscsnes -lpetscts -lpetsc"
+			PETSCLIB="-L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH/ -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetscksp -lpetscdm -lpetscmat -lpetscvec -lpetscsnes -lpetscts -lpetsc"
 			else
-			PETSCLIB="-L$PETSC_ROOT/$PETSC_ARCH/lib -L$PETSC_ROOT/lib/$PETSC_ARCH/ -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetsc"
+			PETSCLIB="-L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH/ -L$PETSC_ROOT/lib -L$PETSC_ROOT/lib/$PETSC_ARCH -lpetsc"
 			fi
 			;;
@@ -1121,4 +1154,19 @@
 
 	dnl Capabilities
+	dnl with-kml{{{
+	AC_ARG_WITH([kml],
+		AS_HELP_STRING([--with-kml = YES],[compile with kml capabilities (default is yes)]),
+		[KML=$withval],[KML=yes]) 
+	AC_MSG_CHECKING(for kml capability compilation)
+
+	if test "x$KML" = "xyes"; then
+		HAVE_KML=yes
+		AC_DEFINE([_HAVE_KML_],[1],[with kml capability])
+	else
+		HAVE_KML=no
+	fi
+	AM_CONDITIONAL([KML], [test x$HAVE_KML = xyes])
+	AC_MSG_RESULT($HAVE_KML)
+	dnl }}}
 	dnl with-kriging{{{
 	AC_ARG_WITH([kriging],
Index: issm/trunk/scripts/DownloadExternalPackage.py
===================================================================
--- issm/trunk/scripts/DownloadExternalPackage.py	(revision 12709)
+++ issm/trunk/scripts/DownloadExternalPackage.py	(revision 13395)
@@ -1,37 +1,135 @@
 #!/usr/bin/env python
 # -*- coding: ISO-8859-1 -*-
+#
+# TODO: Improve upon extension recognition by checking for mismatches in found targets
+# and specified local file.
+#
 
-import os,sys
+import os,sys,re
 import urllib
+from HTMLParser import HTMLParser
+from urllib import FancyURLopener
 
-#Check inputs
-if(len(sys.argv)!=3): raise NameError('usage: ./DownloadExternalPackage.py URL localfile')
+# Start class myHTMLParser
+class MyHTMLParser(HTMLParser):
 
-url=sys.argv[1];
-localFile=sys.argv[2]
+    def __init__(self, pattern):
+        HTMLParser.__init__(self)
+        self.matcher = re.compile(pattern) 
+        self.targets = []
 
-#Remove file if it already exists
-if os.path.exists(localFile):
-	print "File "+ localFile +" already exists and will not be downloaded..."
-	sys.exit()
+    def handle_starttag(self, tag, attrs):
+        for i in attrs:
+            if "href" == i[0] and str(self.matcher.match(i[1])) != "None":
+                self.targets.append(i[1])
+# End class myHTMLParser
 
-#Try to download from url
-httpfail=-1
-try:
-	print "Fetching %s" % localFile
-	urllib.urlretrieve(url,localFile)
-	httpfail=0
-except Exception, e:
-	httpfail=1
+# Separates the URL into a directory and the file or pattern based on the
+# last appearance of '/'.
+if len(sys.argv) > 1:
+    pivot = sys.argv[1].rfind("/")
+    url = (sys.argv[1])[:pivot]
+    pivot += 1
+    find = (sys.argv[1])[pivot:]
+else:
+    print "******************************************************************************************************************************"
+    print "* Invalid input!                                                                                                             *"
+    print "*                                                                                                                            *"
+    print "* Try: 'DownloadExternalPackage.py url [localFile]'                                                                          *"
+    print "*                                                                                                                            *"
+    print "* Where 'URL' is the URL with an explicit package name or the URL followed by the truncated package name. And 'localFile' is *"
+    print "* the file name (including extension) that you would like to save as.                                                        *"
+    print "*                                                                                                                            *"
+    print "* Examples:                                                                                                                  *" 
+    print "*                                                                                                                            *"
+    print "* DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/petsc-2.3.2-p3.tar.gz' 'petsc-2.3.2-p3.tar.gz' *"
+    print "*                                                                                                                            *"
+    print "*     This is the old style and the safest way to download a package.                                                        *"
+    print "*                                                                                                                            *"
+    print "* DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/libtool' 'libtool.tar.gz'                      *"
+    print "*                                                                                                                            *"
+    print "*     This is the new style. For packages like 'Libtool', which we never expect to be using multiple versions, this will     *"
+    print "*     download the most recent version and save it as the generic 'libtool.tar.gz'.                                          *"
+    print "*                                                                                                                            *"
+    print "* DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/gsl-1.' 'gsl-1.15.tar.gz'                      *"
+    print "*                                                                                                                            *"
+    print "*     This is the new style. This is a demonstration of how this script can be used to disambiguate a package name if there  *"
+    print "*     are more than once package matching 'gsl-'.                                                                            *"
+    print "*                                                                                                                            *"
+    print "* DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/libtool'                                       *"
+    print "*                                                                                                                            *"
+    print "*     This is the new style. This will download a package with 'libtool' as a prefix and save it as its canonical name.      *"
+    print "*                                                                                                                            *"
+    print "*                                                                                                                            *"
+    print "******************************************************************************************************************************"
 
-#Error message in case it failed
-if (httpfail):
-	failureMessage = '''
-===========================================================================
-Unable to download package %s from: %s
-* If URL specified manually - perhaps there is a typo?
-* If your network is disconnected - please reconnect 
-* Alternatively, you can download the above URL manually
-===========================================================================
-''' % (localFile,url)
-	raise RuntimeError(failureMessage)
+if len(sys.argv) > 2:
+    localFile=sys.argv[2]
+    print "Downloaded file will saved as: " + localFile
+else:
+    localFile = None
+    print "Downloaded file will saved with the same file name."
+
+
+print "Looking for " + find
+
+# As an extra precaution, if no extension is given for a particular package
+# such as '.../libtool', then ensure that files found are of appropriate
+# file extensions. 
+#
+# WARNING: The external packages directory includes executable binaries with
+# '.exe' extensions. As such, '.exe' is an acceptable suffix, but this is 
+# inherently dangerous since this script can be used to download from any
+# valid website. Furthermore, if an individual attempts a "man-in-the-middle"  
+# attack, then the user would be capable of downloading executables from 
+# an untrusted source.
+pattern = find + "[\w.-]*(\.tar\.gz|tar\.gz2|tgz|zip|exe)?"
+parser = MyHTMLParser(pattern)
+
+# Creates a 'FancyURL' which allows the script to fail gracefully by catching
+# HTTP error codes 30X and several 40X(where 'X' is a natural number).
+urlObject = FancyURLopener()
+obj = urlObject.open(url)
+parser.feed(obj.read())
+
+# If a file pattern was used to describe the file that should be downloaded,
+# then there is the potential for multiple file matches. Currently, the script
+# will detect this ambiguity and print out all the matches, while informing 
+# the user that he must refine his search.
+#
+# TODO: Prompt the user to select from a list his/her preferred target.
+if len(parser.targets) > 1:
+    print "Could not resolve your download due to the number of hits."
+    print "Refine your search."
+    for i in parser.targets:
+        print i
+
+elif len(parser.targets) == 1:
+    print "Found: " + parser.targets[0]
+    url += "/" + parser.targets[0]
+
+    if localFile is None:
+        if os.path.exists(parser.targets[0]): 
+            print "File " + parser.targets[0] + " already exists and will not be downloaded..."
+        else:
+            urllib.urlretrieve(url, parser.targets[0])
+            print "File saved as: " + parser.targets[0]
+    else:
+        if os.path.exists(localFile): 
+            print "File "+ localFile +" already exists and will not be downloaded..."
+        else:
+            if parser.targets[0] == localFile:
+                print "File found and destination match."
+            elif parser.matcher.match(localFile) != "None":
+                print "File found matches destination pattern."
+            else:
+                print "WARNING: the file found \'" + parser.targets[0] + "\' does not match \'" + localFile + "\'"
+                print "Ensure the downloaded version is suitable."
+
+            urllib.urlretrieve(url, localFile)
+            print "File saved as: " + localFile
+
+else:
+    print "No matches found!"
+
+obj.close()
Index: issm/trunk/scripts/automakererun.sh
===================================================================
--- issm/trunk/scripts/automakererun.sh	(revision 12709)
+++ issm/trunk/scripts/automakererun.sh	(revision 13395)
@@ -9,3 +9,3 @@
 
 cd $ISSM_DIR
-autoreconf -iv -I m4
+autoreconf -iv 
Index: issm/trunk/scripts/historyISSM.m
===================================================================
--- issm/trunk/scripts/historyISSM.m	(revision 12709)
+++ issm/trunk/scripts/historyISSM.m	(revision 13395)
@@ -3,9 +3,6 @@
 md.mesh.numberofelements
 md=mesh(md,'DomainOutline.exp',5000);
-md=setmask(md,'','');
 md=setflowequation(md,'macayeal','all');
-md=setflowequation(md,'pattyn','all','stokes','all');
 md=solve(md,TransientSolutionEnum);
-md=solve(md,BalancedthicknessSolutionEnum);
 md=solve(md,DiagnosticSolutionEnum);
 md=loadresultsfromcluster(md);
